################################################
# This file needs to be kept in sync with gitlab-cookbooks/gitlab-alertmanager/templates/default/alertmanager.yml.erb
# It's a temporary state until all config is moved here, see: https://gitlab.com/gitlab-com/gl-infra/infrastructure/issues/7071
################################################

templates:<% @template_locations.each do |location| %>
   - <%= location %>
<% end %>

route:
  repeat_interval: 8h

  # Route most alerts to the main alerts channel in slack
  receiver: main_alerts_channel
  group_by: ['environment', 'tier', 'type', 'alertname', 'stage']

  routes:
  ################################################
  # Send heartbeats to Dead Man's Snitch.
  ################################################
  - match:
      alertname: SnitchHeartBeat
    receiver: dead_mans_snitch
    group_wait: 1m
    group_interval: 5m
    repeat_interval: 5m
    continue: false

  ################################################
  # General Alerts
  # Treat these specially until https://gitlab.com/gitlab-com/gl-infra/infrastructure/issues/4881 is complete
  ################################################

  - match:
      rules_domain: general
      pager: ""
    group_by: ['environment', 'tier', 'type', 'alertname', 'stage']
    receiver: slack_alerts_general
    continue: false
    
  - match:
      rules_domain: general
      pager: "pagerduty"
    group_by: ['environment', 'tier', 'type', 'alertname', 'stage']
    receiver: slack_alerts_general
    continue: true

  ################################################
  # Team Alerts
  # Route certain alerts directly to teams
  ################################################
  # Gitaly warnings do not fallthrough
  - match:
      channel: gitaly
      severity: warn
    group_by: ['environment', 'alertname','instance','job', 'stage']
    receiver: gitaly_low_priority_alerts_channel
    continue: false

  # Gitaly errors do not fallthrough
  - match:
      channel: gitaly
      severity: error
    group_by: ['environment', 'alertname','instance','job', 'stage']
    receiver: gitaly_alerts_channel
    continue: false

  - match:
      channel: gitaly
    group_by: ['environment', 'alertname','instance','job', 'stage']
    receiver: gitaly_alerts_channel
    continue: true

  # ci-cd warnings do not fallthrough
  - match:
      channel: ci-cd
      severity: warn
    group_by: ['environment', 'alertname', 'stage']
    receiver: cicd_alerts_channel
    continue: false

  # ci-cd errors do not fallthrough
  - match:
      channel: ci-cd
      severity: error
    group_by: ['environment', 'alertname', 'stage']
    receiver: cicd_alerts_channel
    continue: false

  - match:
      channel: ci-cd
    group_by: ['environment', 'alertname', 'stage']
    receiver: cicd_alerts_channel
    continue: true

  # database warnings do not fallthrough
  - match:
      channel: database
      severity: warn
    group_by: ['environment', 'alertname', 'stage']
    receiver: database_low_priority_alerts_channel
    continue: false

  # database errors do not fallthrough
  - match:
      channel: database
      severity: error
    group_by: ['environment', 'alertname', 'stage']
    receiver: database_alerts_channel
    continue: false

  - match:
      channel: database
    group_by: ['environment', 'alertname', 'stage']
    receiver: database_alerts_channel
    continue: true

  ################################################
  # Endgate routes: pagerduty and slack
  ################################################
  # Pagerduty alerts go to #production and pagerduty
  # NOTE: Make sure this is the second last matcher
  - match:
      pager: pagerduty
    routes:
    - receiver: non_prod_pagerduty
      match_re:
        environment: gstg|dr|pre
      group_by: ['environment', 'alertname', 'stage']
      continue: false
    - receiver: slo_dr
      match:
        slo_alert: yes
        environment: dr
      continue: false
    - receiver: slo_gprd_cny
      match:
        slo_alert: yes
        environment: gprd
        stage: cny
      continue: true
    - receiver: slo_gprd_main
      match:
        slo_alert: yes
        environment: gprd
        stage: main
      continue: true
    - receiver: pager_alerts_channel
      match:
        slo_alert: yes
      group_by: ['environment', 'tier', 'type', 'alertname', 'stage']
      continue: false
    - receiver: slo_non_prod
      match:
        slo_alert: yes
      continue: false
    - receiver: prod_pagerduty
      group_by: ['environment', 'alertname', 'stage']
      continue: true
    - receiver: pager_alerts_channel
      group_by: ['environment', 'tier', 'type', 'alertname', 'stage']
      continue: true

    continue: false

  # Everything else goes to #alerts
  # NOTE: Make sure this is the last matcher
  - receiver: main_alerts_channel
    group_by: ['environment', 'tier', 'type', 'alertname', 'stage']
    continue: false

receivers:
################################################
# Pagerduty
################################################
- name: prod_pagerduty
  pagerduty_configs:
  - service_key: "<%= prod_pagerduty %>"
    description: '{{ template "slack.title" . }}'
    client: 'GitLab Alertmanager'
    client_url: '{{ template "slack.link" . }}'
    details: { note : '{{ template "slack.text" . }}'}
    send_resolved: true
- name: non_prod_pagerduty
  pagerduty_configs:
  - service_key: "<%= non_prod_pagerduty %>"
    description: '{{ template "slack.title" . }}'
    client: 'GitLab Alertmanager'
    client_url: '{{ template "slack.link" . }}'
    details: { note : '{{ template "slack.text" . }}'}
    send_resolved: true
- name: slo_dr
  pagerduty_configs:
  - service_key: "<%= slo_dr %>"
    description: '{{ template "slack.title" . }}'
    client: 'GitLab Alertmanager'
    client_url: '{{ template "slack.link" . }}'
    details: { note : '{{ template "slack.text" . }}'}
    send_resolved: true
- name: slo_gprd_cny
  pagerduty_configs:
  - service_key: "<%= slo_gprd_cny %>"
    description: '{{ template "slack.title" . }}'
    client: 'GitLab Alertmanager'
    client_url: '{{ template "slack.link" . }}'
    details: { note : '{{ template "slack.text" . }}'}
    send_resolved: true
- name: slo_gprd_main
  pagerduty_configs:
  - service_key: "<%= slo_gprd_main %>"
    description: '{{ template "slack.title" . }}'
    client: 'GitLab Alertmanager'
    client_url: '{{ template "slack.link" . }}'
    details: { note : '{{ template "slack.text" . }}'}
    send_resolved: true
- name: slo_non_prod
  pagerduty_configs:
  - service_key: "<%= slo_non_prod %>"
    description: '{{ template "slack.title" . }}'
    client: 'GitLab Alertmanager'
    client_url: '{{ template "slack.link" . }}'
    details: { note : '{{ template "slack.text" . }}'}
    send_resolved: true

################################################
# Slack Channel Alerts
################################################
- name: "main_alerts_channel"
  slack_configs:
  - api_url: "<%= slack_hook %>"
    send_resolved: true
    channel: "#alerts-ops"
    icon_emoji: '{{ template "slack.icon" . }}'
    color: '{{ template "slack.color" . }}'
    title: '{{ template "slack.title" . }}'
    title_link: '{{ template "slack.link" . }}'
    text: '{{ template "slack.text" . }}'
- name: "pager_alerts_channel"
  slack_configs:
  - api_url: "<%= slack_hook %>"
    send_resolved: true
    channel: "#alerts-ops"
    icon_emoji: '{{ template "slack.icon" . }}'
    color: '{{ template "slack.color" . }}'
    title: '{{ template "slack.title" . }}'
    title_link: '{{ template "slack.link" . }}'
    text: '{{ template "slack.text" . }}'
- name: "database_alerts_channel"
  slack_configs:
  - api_url: "<%= slack_hook %>"
    send_resolved: true
    channel: "#alerts-ops"
    icon_emoji: '{{ template "slack.icon" . }}'
    color: '{{ template "slack.color" . }}'
    title: '{{ template "slack.title" . }}'
    title_link: '{{ template "slack.link" . }}'
    text: '{{ template "slack.text" . }}'
- name: "database_low_priority_alerts_channel"
  slack_configs:
  - api_url: "<%= slack_hook %>"
    send_resolved: true
    channel: "#alerts-ops"
    icon_emoji: '{{ template "slack.icon" . }}'
    color: '{{ template "slack.color" . }}'
    title: '{{ template "slack.title" . }}'
    title_link: '{{ template "slack.link" . }}'
    text: '{{ template "slack.text" . }}'
- name: "gitaly_alerts_channel"
  slack_configs:
  - api_url: "<%= slack_hook %>"
    send_resolved: true
    channel: "#alerts-ops"
    icon_emoji: '{{ template "slack.icon" . }}'
    color: '{{ template "slack.color" . }}'
    title: '{{ template "slack.title" . }}'
    title_link: '{{ template "slack.link" . }}'
    text: '{{ template "slack.text" . }}'
- name: "gitaly_low_priority_alerts_channel"
  slack_configs:
  - api_url: "<%= slack_hook %>"
    send_resolved: true
    channel: "#alerts-ops"
    icon_emoji: '{{ template "slack.icon" . }}'
    color: '{{ template "slack.color" . }}'
    title: '{{ template "slack.title" . }}'
    title_link: '{{ template "slack.link" . }}'
    text: '{{ template "slack.text" . }}'
- name: "cicd_alerts_channel"
  slack_configs:
  - api_url: "<%= slack_hook %>"
    send_resolved: true
    channel: "#alerts-ops"
    icon_emoji: '{{ template "slack.icon" . }}'
    color: '{{ template "slack.color" . }}'
    title: '{{ template "slack.title" . }}'
    title_link: '{{ template "slack.link" . }}'
    text: '{{ template "slack.text" . }}'

# This is temporary while https://gitlab.com/gitlab-com/gl-infra/infrastructure/issues/4881 is ongoing
- name: slack_alerts_general
  slack_configs:
  - api_url: "<%= slack_hook %>"
    channel: '#alerts-gen-svc-test'
    send_resolved: true
    icon_emoji: '{{ template "slack.icon" . }}'
    title: '{{ template "slack.title" . }}'
    title_link: '{{ template "slack.link" . }}'
    text: '{{ template "slack.debug" . }}'

################################################
# WebHooks
################################################
- name: dead_mans_snitch
  webhook_configs:
  - url: "<%= snitch_hook %>"
    send_resolved: false

